
/* (c) Texas Instruments 2009-2010, All rights reserved. */

/* USER CODE BEGIN (0) */
/* USER CODE END */


/* Include Files */

#include "sys_common.h"
#include "system.h"
#include "sys_vim.h"
#include "sys_core.h"
#include "sys_memory.h"

/* USER CODE BEGIN (1) */
/* USER CODE END */


/* Type Definitions */

typedef void (*handler_fptr)(const unsigned char *in, unsigned char *out);

/* USER CODE BEGIN (2) */
/* USER CODE END */


/* External Functions */

#pragma WEAK(__TI_Handler_Table_Base)
#pragma WEAK(__TI_Handler_Table_Limit)
#pragma WEAK(__TI_CINIT_Base)
#pragma WEAK(__TI_CINIT_Limit)

extern unsigned   __TI_Handler_Table_Base;
extern unsigned   __TI_Handler_Table_Limit;
extern unsigned   __TI_CINIT_Base;
extern unsigned   __TI_CINIT_Limit;
extern unsigned   __TI_PINIT_Base;
extern unsigned   __TI_PINIT_Limit;
extern unsigned * __binit__;

extern void main(void);
extern void exit(void);

/* USER CODE BEGIN (3) */
/* USER CODE END */


/* Vim Ram Definition */
/** @struct vimRam
*   @brief Vim Ram Definition
*
*   This type is used to access the Vim Ram.
*/
/** @typedef vimRAM_t
*   @brief Vim Ram Type Definition
*
*   This type is used to access the Vim Ram.
*/
typedef volatile struct vimRam
{
    t_isrFuncPTR ISR[VIM_CHANNELS];
} vimRAM_t;

#define vimRAM ((vimRAM_t *)0xFFF82000U)    /*VIM RAM*/

static const t_isrFuncPTR s_vim_init[] =
{
    phantomInterrupt,
    phantomInterrupt,  /*0*/
    phantomInterrupt,
    rtiCompare0Interrupt,   /*2*/
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,         /* 10 */
    phantomInterrupt,
    phantomInterrupt,
    sci1HighLevelInterrupt,   /*13; LIN level0, this one is used in this project */
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,   /*16; CAN1 level0  */
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,    //20; ESM low level INT
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,    //sci1LowLevelInterrupt,         //27, LIN level1
    phantomInterrupt,
    phantomInterrupt,    //can1LowLevelInterrupt,         //29; ; CAN1 level1  
    phantomInterrupt,               //30
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,        //35, DCAN2 level 0
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,             //40
    phantomInterrupt,
    phantomInterrupt,    //can2LowLevelInterrupt,        //42, DCAN level 1
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,       //49; SPI4 ??
    phantomInterrupt,       //50 
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,      //54, for SPI4??
    phantomInterrupt,      //55
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,      //DCAN3; 60
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,    //sci2HighLevelInterrupt,   //64, SCI level 0 interrupt
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,                //67, OHCI_INT
    phantomInterrupt,          //68 - W2FC IRQ ISO ON
    phantomInterrupt,        //69 - W2FC IRQ GENI ON
    phantomInterrupt,      //70 - W2FC IRQ NON ISO ON
    phantomInterrupt,  //71 - W2FC WAKE REQUEST ON
    phantomInterrupt,          //72 - W2FC RESET
    phantomInterrupt,
    phantomInterrupt,    //sci2LowLevelInterrupt,   //74, SCI level 1 interrupt
    phantomInterrupt,
    phantomInterrupt,       //C0_MISC_PULSE
    phantomInterrupt,       //EMACCore0TxIsr,    //77
    phantomInterrupt,       //C0_THRESH_PULSE
    phantomInterrupt,       //EMACCore0RxIsr,    //79
    phantomInterrupt, 
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt,
    phantomInterrupt       //93
};


/* Startup Routine */

/* USER CODE BEGIN (4) */
/* USER CODE END */

#pragma INTERRUPT(_c_int00, RESET)

void _c_int00()
{
    /* Enable VFP Unit */
    _coreEnableVfp_();
    
    /* Initialize Core Registers */
    _coreInitRegisters_();

    
    /* Initialize Stack Pointers */
    _coreInitStackPointer_();

 
    /* Enable IRQ offset via Vic controller */
    _coreEnableIrqVicOffset_();

    /* Initialize System */
    systemInit();

    /* Run memory tests */
    _memoryTest_();

    /* Initialize memory */
    _memoryInit_();

    /* Initialize VIM table */
    {
        unsigned i;

        for (i = 0; i < VIM_CHANNELS; i++)
        {
            vimRAM->ISR[i] = s_vim_init[i];
        }
    }

    /* set IRQ/FIQ priorities */
    vimREG->FIRQPR0 =  SYS_FIQ                 /*0, ESM high level*/
                    | (SYS_FIQ <<  1U)         
                    | (SYS_IRQ <<  2U)          /*2, RTI*/
                    | (SYS_IRQ <<  3U)         
                    | (SYS_IRQ <<  4U)
                    | (SYS_IRQ <<  5U)
                    | (SYS_IRQ <<  6U)
                    | (SYS_IRQ <<  7U)
                    | (SYS_IRQ <<  8U)
                    | (SYS_IRQ <<  9U)
                    | (SYS_IRQ << 10U)
                    | (SYS_IRQ << 11U)
                    | (SYS_IRQ << 12U)
                    | (SYS_FIQ << 13U)         /*13, LIN level0*/          
                    | (SYS_IRQ << 14U)
                    | (SYS_IRQ << 15U)
                    | (SYS_FIQ << 16U)        /*16, DCAN1 level 0 interrupt*/
                    | (SYS_IRQ << 17U)
                    | (SYS_IRQ << 18U)
                    | (SYS_IRQ << 19U)
                    | (SYS_FIQ << 20U)        /*20, ESM low level*/
                    | (SYS_IRQ << 21U)
                    | (SYS_IRQ << 22U)
                    | (SYS_IRQ << 23U)
                    | (SYS_IRQ << 24U)
                    | (SYS_IRQ << 25U)
                    | (SYS_IRQ << 26U)
                    | (SYS_FIQ << 27U)           /*LIN level1*/
                    | (SYS_IRQ << 28U)
                    | (SYS_FIQ << 29U)           /*CAN1 level 1 */
                    | (SYS_IRQ << 30U)
                    | (SYS_IRQ << 31U);           /*31*/ 

    vimREG->FIRQPR1 =  SYS_IRQ                    /*32*/
                    | (SYS_IRQ <<  1U)
                    | (SYS_IRQ <<  2U)
                    | (SYS_IRQ <<  3U)            /*35, CAN2 level 0 */
                    | (SYS_IRQ <<  4U)
                    | (SYS_IRQ <<  5U)
                    | (SYS_IRQ <<  6U)
                    | (SYS_IRQ <<  7U)
                    | (SYS_IRQ <<  8U)
                    | (SYS_FIQ <<  9U)
                    | (SYS_IRQ << 10U)         /*42, DCAN2 */
                    | (SYS_FIQ << 11U)
                    | (SYS_IRQ << 12U)
                    | (SYS_IRQ << 13U)         /* 45 */
                    | (SYS_IRQ << 14U)
                    | (SYS_IRQ << 15U)
                    | (SYS_IRQ << 16U)
                    | (SYS_FIQ << 17U)
                    | (SYS_IRQ << 18U)         /* 50 */
                    | (SYS_IRQ << 19U)
                    | (SYS_IRQ << 20U)
                    | (SYS_IRQ << 21U)
                    | (SYS_FIQ << 22U)
                    | (SYS_IRQ << 23U)         /* 55 */
                    | (SYS_IRQ << 24U)
                    | (SYS_IRQ << 25U)
                    | (SYS_IRQ << 26U)
                    | (SYS_IRQ << 27U)
                    | (SYS_IRQ << 28U)         /* 60 */
                    | (SYS_IRQ << 29U)
                    | (SYS_IRQ << 30U)
                    | (SYS_IRQ << 31U);        /* 63 */
                    
    vimREG->FIRQPR2 = (SYS_IRQ )            /* 64 */
                    | (SYS_IRQ <<  1U)                   
                    | (SYS_IRQ <<  2U)
                    | (SYS_IRQ <<  3U)                   
                    | (SYS_IRQ <<  4U)
                    | (SYS_IRQ <<  5U)                   
                    | (SYS_IRQ <<  6U)
                    | (SYS_IRQ <<  7U)                   
                    | (SYS_IRQ <<  8U)
                    | (SYS_IRQ <<  9U)                   
                    | (SYS_IRQ <<  10U)
                    | (SYS_IRQ <<  11U)                   
                    | (SYS_IRQ <<  12U)                   
                    | (SYS_IRQ <<  13U)
                    | (SYS_FIQ <<  15U);       /* 78 */

    /* enable interrupts */
    vimREG->REQMASKSET0 = 1U             /*enable*/
                        | (0U << 1)      /*disable*/  
                        | (1U << 2)
                        | (0U << 3)
                        | (0U << 4)
                        | (0U << 5)
                        | (0U << 6)
                        | (0U << 7)
                        | (0U << 8)
                        | (0U << 9)
                        | (0U << 10)
                        | (0U << 11)
                        | (0U << 12)
                        | (1U << 13)   //lin        
                        | (0U << 14)
                        | (0U << 15)
                        | (1U << 16)   //dcan1
                        | (0U << 17)
                        | (0U << 18)
                        | (0U << 19)
                        | (1U << 20)   //ESM
                        | (0U << 21)
                        | (0U << 22)
                        | (0U << 23)
                        | (0U << 24)
                        | (0U << 25)
                        | (0U << 26)
                        | (1U << 27)    //Lin
                        | (0U << 28)
                        | (1U << 29)   //dcan1
                        | (0U << 30)
                        | (0U << 31);  

    vimREG->REQMASKSET1 = 0U
                        | (0U << 1)
                        | (0U << 2)
                        | (1U << 3)    //35, dcan2
                        | (0U << 4)
                        | (0U << 5)
                        | (0U << 6)
                        | (0U << 7)
                        | (0U << 8)
                        | (0U << 9)
                        | (1U << 10)    //42, dcan2
                        | (0U << 11)
                        | (0U << 12)
                        | (0U << 13)    //45
                        | (0U << 14)
                        | (0U << 15)
                        | (0U << 16)
                        | (0U << 17)   //49
                        | (0U << 18)   //50
                        | (0U << 19)
                        | (0U << 20)
                        | (0U << 21)
                        | (1U << 22)
                        | (0U << 23)    //55
                        | (0U << 24)
                        | (0U << 25)
                        | (0U << 26)
                        | (0U << 27)
                        | (0U << 28)   //60
                        | (0U << 29)
                        | (0U << 30)
                        | (0U << 31);  //63
                        
    vimREG->REQMASKSET2 = (0 <<  0U)   //64, SCI, level0
                    	| (0 <<  1U)
                    	| (0 <<  2U)
                    	| (1 <<  3U)    //67, OHCI
                    	| (1 <<  4U)    //68, W2FC
                    	| (1 <<  5U)    //69, W2FC
                    	| (1 <<  6U)    //70, W2FC
                    	| (0 <<  7U)    //71, W2FC, have to be disabled for USB
                    	| (1 <<  8U)    //72, W2FC  
                    	| (1 <<  9U)   //73
                    	| (0 <<  10U)
                    	| (0 <<  13U)
                    	| (0 <<  15U);   //76


    /* initalise copy table */
    if ((unsigned *)&__binit__ != (unsigned *)0xFFFFFFFF)
    {
        extern void copy_in(void *binit);
        copy_in((void *)&__binit__);
    }

    /* initalise the C global variables */
    if (&__TI_Handler_Table_Base < &__TI_Handler_Table_Limit)
    {
        unsigned char **tablePtr   = (unsigned char **)&__TI_CINIT_Base;
        unsigned char **tableLimit = (unsigned char **)&__TI_CINIT_Limit;

        while (tablePtr < tableLimit)
        {
            unsigned char *loadAdr = *tablePtr++;
            unsigned char *runAdr  = *tablePtr++;
            unsigned char  idx     = *loadAdr++;
            handler_fptr   handler = (handler_fptr)(&__TI_Handler_Table_Base)[idx];

            (*handler)((const unsigned char *)loadAdr, runAdr);
        }
    }

    /* initalise contructors */
    if (__TI_PINIT_Base < __TI_PINIT_Limit)
    {
        void (**p0)() = (void *)__TI_PINIT_Base;

        while ((unsigned)p0 < __TI_PINIT_Limit)
        {
            void (*p)() = *p0++;
            p();
        }
    }

/* USER CODE BEGIN (5) */
/* USER CODE END */

    /* call the application */
    main();
    exit();
}


/* USER CODE BEGIN (6) */
/* USER CODE END */
